module BDIO

import Nettle

# Include constant values and global variables
include("BDIOvalues.jl") 

# Include types
include("BDIOtypes.jl") 

# Include methods
include("BDIOmethods.jl")

# Constants
export BDIO_BIN_GENERIC, BDIO_ASC_EXEC, BDIO_BIN_INT32BE,
    BDIO_BIN_INT32LE, BDIO_BIN_INT64BE, BDIO_BIN_INT64LE,
    BDIO_BIN_F32BE, BDIO_BIN_F32LE, BDIO_BIN_F64BE, BDIO_BIN_F64LE,
    BDIO_ASC_GENERIC, BDIO_ASC_XML, BDIO_BIN_INT32, BDIO_BIN_INT64,
    BDIO_BIN_F32, BDIO_BIN_F64 

# Methods
export BDIOstream, BDIO_open, BDIO_start_record!, BDIO_write_hash!,
    BDIO_write!, BDIO_seek!, BDIO_get_len, BDIO_get_fmt, BDIO_eor, 
    BDIO_get_uinfo, BDIO_read, BDIO_set_user, BDIO_set_host, BDIO_close!


function Base.show(io::IO, fb::BDIOstream)
    
    if (fb.imode == BDIO_R_MODE)
        print("BDIOstream in read mode")
    else
        print("BDIOstream in write mode")
    end
end


end # module
